
<!DOCTYPE html>
<html>
<head>
      <!-- Google Tag Manager -->
    <script>(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
    new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
    j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
    'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
    })(window,document,'script','dataLayer','G-Y0WQ34JPKJ');</script>
<!-- End Google Tag Manager -->
    <meta charset="UTF-8">
    <title>운세보는 쳇술사</title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://fonts.googleapis.com/css2?family=Noto+Sans+KR:wght@100;300;400;500;700;900&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css" integrity="sha512-SzlrxWUlpfuzQ+pcUCosxcglQRNAq/DZjVsC0lE40xsADsfeQoEypE+enwcOiGjk/bSuGGKHEyjSoQ1zVisanQ==" crossorigin="anonymous" referrerpolicy="no-referrer" />
    <link rel="manifest" href="/manifest.json">
    <script>
        if ('serviceWorker' in navigator) {
        window.addEventListener('load', () => {
            navigator.serviceWorker.register('./serviceWorker.js')
            .then(registration => {
                console.log('Service worker registered:', registration);
            })
            .catch(error => {
                console.log('Service worker registration failed:', error);
            });
        });
        }
    </script>
    <style>
        
        body {
            margin: 0;
            padding: 0;
            font-family: Arial, sans-serif;
            font-size: 14px;
            background-image: url('img/image.jpg'); /* replace with your own image path */
            background-position: 100%;
        }

        .containers {
            
            max-width: 500px;
            margin: 10px auto;
            border: 1px solid #7693e2;
            border-radius: 5px;

            /* max-width: 500px;
            margin: 0 auto; */
            background-color: #333030;
            /* box-shadow: 0 0 10px rgba(0, 0, 0, 0.2); */
         }

        .chat-container {
            display: flex;
            flex-direction: row;
            
            max-width: 500px;
            margin: 10px auto;
            /* border: 1px solid #7693e2; */
            border-radius: 5px;

            /* max-width: 500px;
            margin: 0 auto; */
            background-color: #333030;
            /* box-shadow: 0 0 10px rgba(0, 0, 0, 0.2); */
         }

        .chat-container img {
            width: 30%;
            min-width: 100%;
            height: 80%;
        }
        .chat-box {
            background-color: #333030;
            padding: 10px;
            border-radius: 10px;
            margin-bottom: 20px;
            overflow-y: scroll;
            height: 200px;
        }

        .chat-message {


            border-radius: 20px;

            background-color: #5695dd;
            color: #030303;
            border-radius: 20px;
            padding: 5px 5px;
            margin-right: auto;
            max-width: 80%;
            font-size: 13px;
        }

        .chat-message p {
            margin: 5px;
            padding: 5px;
            
        }

        .chat-message img {
            min-width: 80%;
            align-items: center;
        }
        .chat-input {
            display: flex;
            align-items: center;
            padding: 10px 20px;
        }

        .chat-input input {
            flex: 1;
            padding: 10px;
            border: none;
            border-radius: 5px;
            margin-right: 10px;
        }

        .chat-input button {
            background-color: #bbc7bb;
            color: #fff;
            border: none;
            padding: 10px;
            border-radius: 5px;
            cursor: pointer;
        }

        .chat-input button:hover {
            background-color: #3e8e41;
        }

        .assistant {
            color: #030303;
            display: flex;
        }

        .intro-container {
            display: flex;
            flex-direction: column;
            
            max-width: 500px;
            margin: 10px auto;
            /* border: 1px solid #7693e2; */
            border-radius: 5px;
            background-color: #333030;
            /* box-shadow: 0 0 10px rgba(0, 0, 0, 0.2); */
        }

        .intro-container img {
            min-width: 80%;
            align-items: center;
            height: 80%;
        }

        
        .intro-container select {
            min-width: 80%;
            font-family: Arial, sans-serif;
            font-size: 12px;
            border-radius: 20px;
            background-color: #e7c7c7;
            margin-bottom: 20px;
        }
        
        .intro-container button {
            min-width: 80%;
            background-color: #98fc98;
            border-radius: 20px;
            margin-bottom: 15px;
        }

  
        #loader {
            font-size: 20px;
            text-align: left;
            margin-left: 20px;
            color: #5695dd;
        }

        label {
            display: white;
            margin-bottom: 10px;
            font-weight: bold;
            font-size: 16px;
        }

        input[type="date"] {

            background-color: #e7c7c7;
            font-size: 13px;
            margin-bottom: 15px;
            border-radius: 20px;

        }

        #birthdate {
            color: rgb(226, 214, 214);
        }

        .user-message {
            border-radius: 20px;
            margin-top: 5px;
            margin-bottom: 5px;
            background-color: #6aec58;
            color: #030303;
            border-radius: 20px;
            padding: 5px 5px;
            margin-left: auto;
            max-width: 60%;
            text-align: center;
            font-size: 13px;
        }        

        .kakao-ad{
            display: flex;
            justify-content: center;

            margin-top: 20px;
            min-width: 80%;
            min-height: 250px;
        }

        .kakao-ad2{
            display: flex;
            justify-content: center;

            margin-top: 20px;
            min-width: 80%;
            min-height: 250px;
        }        

        .background-image {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            z-index: -1;
            background-image: url(img/image.jpg);
            background-repeat: no-repeat;
            background-size: cover;
            background-position: center center;
            opacity: 0.7;
            filter: grayscale(50%);
        }  
        
        .kakao-ad3{
            display: flex;
             justify-content: right;

            margin-top: 20px;
            min-width: 80%;
            min-height: 600px;
        }  
    </style>
</head>

<body>

        <script type="text/javascript" src="//t1.daumcdn.net/kas/static/ba.min.js" async></script></div>
    <div id="chats" class="containers">
        <div id="intro" class="intro-container">
            <h2 ID="birthdate" align="center">AI가 운세에 대해서 알려줘요!</h2>
            <img src="img/generated_image.png" alt="chatsulsa">
            <label for="date" ID="birthdate">생년월일</label>
            <input id="date" type="date"  >
            <label for="hour" ID="birthdate">태어난 시간</label>
            <select id="hour" name="hour" >
                <option value="">모름</option>
                <option value="00">00</option>
                <option value="01">01</option>
                <option value="02">02</option>
                <option value="03">03</option>
                <option value="04">04</option>
                <option value="05">05</option>
                <option value="06">06</option>
                <option value="07">07</option>
                <option value="08">08</option>
                <option value="09">09</option>
                <option value="10">10</option>
                <option value="11">11</option>
                <option value="12">12</option>
                <option value="13">13</option>
                <option value="14">14</option>
                <option value="15">15</option>
                <option value="16">16</option>
                <option value="17">17</option>
                <option value="18">18</option>
                <option value="19">19</option>
                <option value="20">20</option>
                <option value="21">21</option>
                <option value="22">22</option>
                <option value="23">23</option>
                <option value="24">24</option>
            </select>
            <button onclick="start()">시작하기</button>
        </div>
        <div id="chat" class="chat-container" style="display: none;">
            <h2 ID="birthdate" align="center">쳇술사에게 물어봐주세요^^</h2>
            <img src="img/generated_image.png" alt="chatsulsa">
            <div class="chat-box">
                <div class="chat-message"></div>
            </div>
            <div id="loader" class="loader" style="display: none;">
                <i class="fa fa-spinner fa-spin"></i>
            </div>
            <div class="chat-input">
                <input type="text" id="message-input" placeholder="쳇술사에게 여기로 물어봐주세요^^">
                <!-- <button id="btn" onclick="spinner()">Send</button> -->
                <button id="btn" onclick="spinner()">
                    <i class="fa-regular fa-paper-plane"></i>
                </button>
            </div>
        </div>
    </div>
    
    <script>

        
        const chatBox = document.querySelector('.chat-box');
        let userMessages = [];
        let assistantMessages = [];
        let myDate = '';
        let myDateTime = ''

        function spinner() {
            
            const sCheck = document.querySelector('.chat-input input');
            if(sCheck.value != '' && sCheck.value != null){
                document.getElementById('loader').style.display = "block";
            }
            else{
                sCheck.focus();
            }

        }

        function start() {
            const date = document.getElementById('date').value;
            const hour = document.getElementById('hour').value;
            if (date === '') {
                alert('생년월일을 입력해주세요.');
                return;
            }
            myDateTime = date + hour;
            myDate = date;

            document.getElementById("intro").style.display = "none";
            document.getElementById("chat").style.display = "block";
            document.getElementById("message-input").value = "오늘 나의 운세 알려줘?";
            

            spinner();
            sendMessage();
        }

        function sleep(sec) {
            return new Promise(resolve => setTimeout(resolve, sec * 1000));
        }

        const sendMessage = async () => {
            const chatInput = document.querySelector('.chat-input input');
            const chatMessage = document.createElement('div');

            chatMessage.classList.add('user-message');
            chatMessage.innerHTML = `<p>${chatInput.value}</p>`;
            chatBox.appendChild(chatMessage);
            chatBox.scrollTop = chatBox.scrollHeight;

            //userMessage 메세지 추가 
            userMessages.push(chatInput.value);

            chatInput.value = '';

            const maxRetries = 3;
            let retries = 0;
            let nCount = 0;
            while (retries < maxRetries) {
                try {            		// AWS Lambda에 정의한 함수 링크
                    const response = await fetch('https://qhcbarowyptynuxp3nmllwukia0xdeyn.lambda-url.ap-northeast-2.on.aws/fortuneChat', {
                        method: 'POST',
                        headers: {
                        "Content-Type": "application/json"
                        },
                        body: JSON.stringify({
                            myDateTime: myDateTime,
                            userMessages: userMessages,
                            assistantMessages: assistantMessages,
                        })
                    });

                    const data = await response.json();
                    document.getElementById('loader').style.display = "none";
                    
                    //assistantMessage 메세지 추가
                    assistantMessages.push(data.assistant);

                    const astrologerMessage = document.createElement('div');
                    astrologerMessage.classList.add('chat-message');
                    // 문장 구분 기준을 정의합니다.
                    const sentenceSeparator = /[.?!]/;

                    let imsiSen = "";
                    imsiSen = myDate+"에 태어난 당신의 오늘 운세 입니다.";

                    if (data.assistant && assistantMessages.length == 1) {
                        imsiSen += data.assistant;
                    }
                    else{
                        imsiSen = "";
                        imsiSen =  data.assistant;
                    }
                    
                    // 문장으로 분리합니다.
                    const sentences = imsiSen.split(sentenceSeparator);

                    // 문장을 담을 배열을 생성합니다.
                    const paragraph = [];

                    // 반복문을 사용하여 각 문장의 끝에 <br> 태그를 추가한 후, 배열에 추가합니다.
                    for (let i = 0; i < sentences.length; i++) {
                        const sentence = sentences[i].trim() + "<br><br>";
                        paragraph.push(sentence);
                    }

                    // 문장 배열을 이용하여 문단을 생성합니다.
                    const finalParagraph = paragraph.join("");            
                    astrologerMessage.innerHTML = `<p class='assistant'>${finalParagraph}</p>`;

                    if(assistantMessages.length != 0 && assistantMessages.length % 2 == 0){
                        const link = document.createElement('a');
                        link.href = "https://toss.me/pdori"
                        link.innerText = "복채 보내기";
                        astrologerMessage.innerHTML+="<br> 작은 정성 배풀어주시면 더욱 좋은 운이 있으실겁니다. => "
                        astrologerMessage.appendChild(link);

                    }
                   
                    chatBox.appendChild(astrologerMessage);
                    chatBox.scrollTop = chatBox.scrollHeight

                    break;
                } catch (error) {
                    await sleep(0.5);
                    retries++;
                    console.log(error);
                    console.log(`Error fetching data, retrying (${retries}/${maxRetries})...`);
                    if (retries === 3) {
                        alert("서버가 불안정합니다. 잠시 후 다시 시도해주세요!")
                    }
                }
            }
        };

        document.querySelector('.chat-input button').addEventListener('click', function(event) {
            const sCheck = document.querySelector('.chat-input input');
            if(sCheck.value != '' && sCheck.value != null){
                sendMessage();
            }
            else{
                sCheck.focus();
            }
        });

        const messageInput = document.getElementById('message-input');
        messageInput.addEventListener("keydown", function(event) {
            const sCheck = document.querySelector('.chat-input input');
            if (event.key === "Enter") {
                if(sCheck.value != '' && sCheck.value != null){
                    spinner();
                    sendMessage();

                }
                else{
                    sCheck.focus();
                }
             }
        });
    </script>
</body>

</html>